//キーボードパネル　Ver.0.0.1
//ブラウザのキオスクモードなどでも使えるような、ブラウザ上にキーボードを
//表示する仕組みです。
//</body>の直前にファイル[keypanel.js]を呼び出してください。
//漢字変換などは出来ません。
//また、inpytタイプがtextのみの対応なので、textboxやpasswordなどで、
//表示できなくなっています。
//出来るようにしたい場合には、dispPanel関数の、if文を変更したらよいです。
//単体で、というよりもGoogleの機能拡張として使えるように考えていますので、
//[keypanel.zip]をダウンロード・解凍したあと、そのフォルダを、
//Chromeの機能拡張（ディベロッパーモードにして）で、指定してみてください。
//(たぶん、鬱陶しいので、普段は無効にしとくとよいです）
//
//最後に、この「キーボードパネル」については、自由に変更、配布していただいて構いません。
//ただし利用は自己責任でお願いします。
//使った結果についてｈ、wemflsは一切責任を持ちません。

var frdocActive;
var frdocPosition;
var keyPanelId = "keypanel";
function startKeyPanel(){//キーボードパネルプログラムのスタート。このファイルの最後の行で実行
//	console.log("keyPanel start");
	document.onclick = dispPanel;
	
	var bd = document.getElementsByTagName('body')[0];
	
	var keyPanel = document.createElement('div');
	keyPanel.setAttribute('id',keyPanelId);
	bd.appendChild(keyPanel);
	setKeyMode('かな');
	keyPanel.style.display="none";
}
function setKey(){//キーボードをクリックした時の処理
	if(this.value=="パネル\n消去"){
		frdocActive = "";
		document.getElementById(keyPanelId).style.display="none";
	}else if(this.value=="一字\n削除"){
		if(frdocActive.value.length >=1){
			if(frdocPosition==0){
				frdocActive.value = frdocActive.value.substring(0, frdocActive.value.length-1);
			}else{
				frdocActive.value = frdocActive.value.substring(0, frdocPosition-1)+frdocActive.value.substring(frdocPosition, frdocActive.value.length);
				frdocPosition =frdocPosition-1;
			}
		}
	}else if(this.value=="変換"&&frdocActive.value!=""){
		if(frdocActive.value.indexOf('　')>=0){
			var word = frdocActive.value.split('　');
			word = word[word.length-1];
		}else{
			var word = frdocActive.value;
		}
		var url = "http://www.google.com/transliterate?langpair=ja-Hira|ja&text="+encodeURI(word+',');
		chrome.extension.sendRequest({jsonp: url},function(response) {
//console.log(response.henkan);
			ImeCallback(response.henkan);
		});
	}else if(this.value=="゛゜ぁ"||this.value=="゛゜ァ"){
//console.log(frdocActive.value.substring(frdocPosition-1,frdocPosition));
		var dakuten=changeDaku(frdocActive.value.substring(frdocPosition-1,frdocPosition))
		frdocActive.value = frdocActive.value.substring(0, frdocPosition-1)+dakuten+frdocActive.value.substring(frdocPosition, frdocActive.value.length);
	}else if(this.value=="かな"||this.value=="゛゜ぁ"||this.value=="英数"||this.value=="大文字"||this.value=="カナ"){
		setKeyMode(this.value);
	}else if(this.value==" "){
		
	}else{
		frdocActive.value = frdocActive.value.substring(0, frdocPosition)+this.value+frdocActive.value.substring(frdocPosition, frdocActive.value.length);
		frdocPosition =frdocPosition+1;
	}
	document.getElementById('henkan').innerHTML='';
}
function dispPanel(){//inputタイプがテキストのものがアクティブ（選択）されたときに、キーボードパネルを表示する
	if(document.activeElement.type=="text"){
		frdocActive = document.activeElement;
		document.getElementById(keyPanelId).style.display="block";
		frdocPosition=frdocActive.selectionStart;
//console.log(frdocActive.selectionStart);
	}
}
function changeDaku(key){//文字を濁点・半濁点・小さい字に変換して返す
	switch(key){
		case "あ":return "ぁ"; break;
		case "ぁ":return "あ"; break;
		case "い":return "ぃ"; break;
		case "ぃ":return "い"; break;
		case "う":return "ぅ"; break;
		case "ぅ":return "う"; break;
		case "え":return "ぇ"; break;
		case "ぇ":return "え"; break;
		case "お":return "ぉ"; break;
		case "ぉ":return "お"; break;
		case "か":return "が"; break;
		case "が":return "か"; break;
		case "き":return "ぎ"; break;
		case "ぎ":return "き"; break;
		case "く":return "ぐ"; break;
		case "ぐ":return "く"; break;
		case "け":return "げ"; break;
		case "げ":return "け"; break;
		case "こ":return "ご"; break;
		case "ご":return "こ"; break;
		case "さ":return "ざ"; break;
		case "ざ":return "さ"; break;
		case "し":return "じ"; break;
		case "じ":return "し"; break;
		case "す":return "ず"; break;
		case "ず":return "す"; break;
		case "せ":return "ぜ"; break;
		case "ぜ":return "せ"; break;
		case "そ":return "ぞ"; break;
		case "ぞ":return "そ"; break;
		case "た":return "だ"; break;
		case "だ":return "た"; break;
		case "ち":return "ぢ"; break;
		case "ぢ":return "ち"; break;
		case "つ":return "づ"; break;
		case "づ":return "っ"; break;
		case "っ":return "つ"; break;
		case "て":return "で"; break;
		case "で":return "て"; break;
		case "と":return "ど"; break;
		case "ど":return "と"; break;
		case "は":return "ば"; break;
		case "ば":return "ぱ"; break;
		case "ぱ":return "は"; break;
		case "ひ":return "び"; break;
		case "び":return "ぴ"; break;
		case "ぴ":return "ひ"; break;
		case "ふ":return "ぶ"; break;
		case "ぶ":return "ぷ"; break;
		case "ぷ":return "ふ"; break;
		case "へ":return "べ"; break;
		case "べ":return "ぺ"; break;
		case "ぺ":return "へ"; break;
		case "ほ":return "ぼ"; break;
		case "ぼ":return "ぽ"; break;
		case "ぽ":return "ほ"; break;
		case "や":return "ゃ"; break;
		case "ゃ":return "や"; break;
		case "ゆ":return "ゅ"; break;
		case "ゅ":return "ゆ"; break;
		case "よ":return "ょ"; break;
		case "ょ":return "よ"; break;
		case "ア":return "ァ"; break;
		case "ァ":return "ア"; break;
		case "イ":return "ィ"; break;
		case "ィ":return "イ"; break;
		case "ウ":return "ヴ"; break;
		case "ヴ":return "ゥ"; break;
		case "ゥ":return "ウ"; break;
		case "エ":return "ェ"; break;
		case "ェ":return "エ"; break;
		case "オ":return "ォ"; break;
		case "ォ":return "オ"; break;
		case "カ":return "ガ"; break;
		case "ガ":return "カ"; break;
		case "キ":return "ギ"; break;
		case "ギ":return "キ"; break;
		case "ク":return "グ"; break;
		case "グ":return "ク"; break;
		case "ケ":return "ゲ"; break;
		case "ゲ":return "ケ"; break;
		case "コ":return "ゴ"; break;
		case "ゴ":return "コ"; break;
		case "サ":return "ザ"; break;
		case "ザ":return "サ"; break;
		case "シ":return "ジ"; break;
		case "ジ":return "シ"; break;
		case "ス":return "ズ"; break;
		case "ズ":return "ス"; break;
		case "セ":return "ゼ"; break;
		case "ゼ":return "セ"; break;
		case "ソ":return "ゾ"; break;
		case "ゾ":return "ソ"; break;
		case "タ":return "ダ"; break;
		case "ダ":return "タ"; break;
		case "チ":return "ヂ"; break;
		case "ヂ":return "チ"; break;
		case "ツ":return "ヅ"; break;
		case "ヅ":return "ッ"; break;
		case "ッ":return "ツ"; break;
		case "テ":return "デ"; break;
		case "デ":return "テ"; break;
		case "ト":return "ド"; break;
		case "ド":return "ト"; break;
		case "ハ":return "バ"; break;
		case "バ":return "パ"; break;
		case "パ":return "ハ"; break;
		case "ヒ":return "ビ"; break;
		case "ビ":return "ピ"; break;
		case "ピ":return "ヒ"; break;
		case "フ":return "ブ"; break;
		case "ブ":return "プ"; break;
		case "プ":return "フ"; break;
		case "ヘ":return "ベ"; break;
		case "ベ":return "ペ"; break;
		case "ペ":return "ヘ"; break;
		case "ホ":return "ボ"; break;
		case "ボ":return "ポ"; break;
		case "ポ":return "ホ"; break;
		case "ヤ":return "ャ"; break;
		case "ャ":return "ヤ"; break;
		case "ユ":return "ュ"; break;
		case "ュ":return "ユ"; break;
		case "ヨ":return "ョ"; break;
		case "ョ":return "ヨ"; break;
		default : return key; break;
	}
}
function ImeCallback(result){
	var div = document.getElementById('henkan');
	if(div){
//console.log("get henkan Div");
		div.innerHTML ='';
		var wordList='';
//console.log(result.length);
		for(i=0; i<result.length; i++){
			var word = result[i];
			if(typeof word =='object'){
				for(j=0; j<word.length; j++){wordList += word[j]+',';}
			}
		}
		wordList = wordList.split(',');
		for(i=0; i<wordList.length; i++){
			if(wordList[i]!=''){
				var b=document.createElement('input');
				b.setAttribute('type','button');
				b.setAttribute('value',wordList[i]);
				b.onclick=ImeSetText;
				div.appendChild(b);
			}
		}
	}
}
function ImeSetText(){
	if(frdocActive.value.indexOf('　')>=0){
		var word = frdocActive.value.split('　');
		frdocActive.value='';
		for(i=0; i<word.length-1; i++){
			frdocActive.value+=word[i]+'　';
		}
		frdocActive.value+=this.value;
	}else{
		frdocActive.value =this.value;
	}
	document.getElementById('henkan').innerHTML='';
}
function setKeyMode(code){//かなやカナ、英数などで表示するキーボードを表示
	var keyPanel = document.getElementById(keyPanelId);
	keypanel.innerHTML='<div id="henkan"></div><br>';
	if(code=='かな'){
		keyPanel.innerHTML+='<input type="button" value="あ"><input type="button" value="い"><input type="button" value="う"><input type="button" value="え"><input type="button" value="お">　<input type="button" value="は"><input type="button" value="ひ"><input type="button" value="ふ"><input type="button" value="へ"><input type="button" value="ほ"><br>';
		keyPanel.innerHTML+='<input type="button" value="か"><input type="button" value="き"><input type="button" value="く"><input type="button" value="け"><input type="button" value="こ">　<input type="button" value="ま"><input type="button" value="み"><input type="button" value="む"><input type="button" value="め"><input type="button" value="も"><br>';
		keyPanel.innerHTML+='<input type="button" value="さ"><input type="button" value="し"><input type="button" value="す"><input type="button" value="せ"><input type="button" value="そ">　<input type="button" value="や"><input type="button" value=" "><input type="button" value="ゆ"><input type="button" value=" "><input type="button" value="よ"><br>';
		keyPanel.innerHTML+='<input type="button" value="た"><input type="button" value="ち"><input type="button" value="つ"><input type="button" value="て"><input type="button" value="と">　<input type="button" value="ら"><input type="button" value="り"><input type="button" value="る"><input type="button" value="れ"><input type="button" value="ろ"><br>';
		keyPanel.innerHTML+='<input type="button" value="な"><input type="button" value="に"><input type="button" value="ぬ"><input type="button" value="ね"><input type="button" value="の">　<input type="button" value="わ"><input type="button" value="を"><input type="button" value="ん"><input type="button" value="ー"><input type="button" value="゛゜ぁ"><br>';
		keyPanel.innerHTML+='<input type="button" value="カナ"><input type="button" value="英数"><input type="button" value="　" class="spacekey"><input type="button" value="変換"><input type="button" value="一字\n削除"><input type="button" value="パネル\n消去"><br>'
	}else if(code=='英数'){
		keyPanel.innerHTML+='<input type="button" value="1"><input type="button" value="2"><input type="button" value="3"><input type="button" value="4"><input type="button" value="5"><input type="button" value="6"><input type="button" value="7"><input type="button" value="8"><input type="button" value="9"><input type="button" value="0"><input type="button" value="-"><br>';
		keyPanel.innerHTML+='<input type="button" value="q"><input type="button" value="w"><input type="button" value="e"><input type="button" value="r"><input type="button" value="t"><input type="button" value="y"><input type="button" value="u"><input type="button" value="i"><input type="button" value="o"><input type="button" value="p"><br>';
		keyPanel.innerHTML+='<input type="button" value="a"><input type="button" value="s"><input type="button" value="d"><input type="button" value="f"><input type="button" value="g"><input type="button" value="h"><input type="button" value="j"><input type="button" value="k"><input type="button" value="l"><br>';
		keyPanel.innerHTML+='<input type="button" value="z"><input type="button" value="x"><input type="button" value="c"><input type="button" value="v"><input type="button" value="b"><input type="button" value="n"><input type="button" value="m"><input type="button" value="大文字"><br>';
		keyPanel.innerHTML+='<input type="button" value="かな"><input type="button" value="カナ"><input type="button" value="　" class="spacekey"><input type="button" value="変換"><input type="button" value="一字\n削除"><input type="button" value="パネル\n消去"><br>'
	}else if(code=='大文字'){
		keyPanel.innerHTML+='<input type="button" value="!"><input type="button" value="&quot;"><input type="button" value="#"><input type="button" value="$"><input type="button" value="%"><input type="button" value="&"><input type="button" value="+"><input type="button" value="/"><input type="button" value="@"><input type="button" value=","><input type="button" value="."><br>';
		keyPanel.innerHTML+='<input type="button" value="Q"><input type="button" value="W"><input type="button" value="E"><input type="button" value="R"><input type="button" value="T"><input type="button" value="Y"><input type="button" value="U"><input type="button" value="I"><input type="button" value="O"><input type="button" value="P"><br>';
		keyPanel.innerHTML+='<input type="button" value="A"><input type="button" value="S"><input type="button" value="D"><input type="button" value="F"><input type="button" value="G"><input type="button" value="H"><input type="button" value="J"><input type="button" value="K"><input type="button" value="L"><br>';
		keyPanel.innerHTML+='<input type="button" value="Z"><input type="button" value="X"><input type="button" value="C"><input type="button" value="V"><input type="button" value="B"><input type="button" value="N"><input type="button" value="M"><input type="button" value="英数"><br>';
		keyPanel.innerHTML+='<input type="button" value="かな"><input type="button" value="カナ"><input type="button" value="　" class="spacekey"><input type="button" value="変換"><input type="button" value="一字\n削除"><input type="button" value="パネル\n消去"><br>'
	}else if(code=='カナ'){
		keyPanel.innerHTML+='<input type="button" value="ア"><input type="button" value="イ"><input type="button" value="ウ"><input type="button" value="エ"><input type="button" value="オ">　<input type="button" value="ハ"><input type="button" value="ヒ"><input type="button" value="フ"><input type="button" value="へ"><input type="button" value="ホ"><br>';
		keyPanel.innerHTML+='<input type="button" value="カ"><input type="button" value="キ"><input type="button" value="ク"><input type="button" value="ケ"><input type="button" value="コ">　<input type="button" value="マ"><input type="button" value="ミ"><input type="button" value="ム"><input type="button" value="メ"><input type="button" value="モ"><br>';
		keyPanel.innerHTML+='<input type="button" value="サ"><input type="button" value="シ"><input type="button" value="ス"><input type="button" value="セ"><input type="button" value="ソ">　<input type="button" value="ヤ"><input type="button" value=" "><input type="button" value="ユ"><input type="button" value=" "><input type="button" value="ヨ"><br>';
		keyPanel.innerHTML+='<input type="button" value="タ"><input type="button" value="チ"><input type="button" value="ツ"><input type="button" value="テ"><input type="button" value="ト">　<input type="button" value="ラ"><input type="button" value="リ"><input type="button" value="ル"><input type="button" value="レ"><input type="button" value="ロ"><br>';
		keyPanel.innerHTML+='<input type="button" value="ナ"><input type="button" value="ニ"><input type="button" value="ヌ"><input type="button" value="ネ"><input type="button" value="ノ">　<input type="button" value="ワ"><input type="button" value="ヲ"><input type="button" value="ン"><input type="button" value="ー"><input type="button" value="゛゜ァ"><br>';
		keyPanel.innerHTML+='<input type="button" value="かな"><input type="button" value="英数"><input type="button" value="　" class="spacekey"><input type="button" value="変換"><input type="button" value="一字\n削除"><input type="button" value="パネル\n消去"><br>'
	}
	keyPanel.innerHTML+='';
	var btn = keyPanel.getElementsByTagName("input");
	var len = btn.length;
	for(var i=0; i<len; i++){btn[i].onclick=setKey;}
}
startKeyPanel();
